/** 
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 * */
function argmin(arr=[],key=parseInt)
{
    var k=arr.map(x=>key(x)).map(x=>isNaN(x)?Infinity:x)
    var kmin=Math.min(...(k.flat()))
    return k.findIndex(x=>x==kmin)
}
/**
 * @template T
 * @param {T[]} arr
 * @param {(x:T)=>Number} key
 * @returns {T}
 */
function min(arr=[],key=parseInt)
{return arr[argmin(arr,key)]}

var enemyPlayer=null
var enemy=null
function goodResearch(name="")
{
    var cost=getResearch(name).power
    
    if (getResearch(name).started)return 999
    if (name.startsWith("R-Sys-Autorepair-General"))return -1000
    if (name.startsWith("R-Struc-Research-Upgrade"))return -999

    if (name.includes("Plasm"))return -25
    if (name.includes("Flame"))return -25//(name.startsWith("R-Wpn-MG"))return -25
    if (name.includes("Metals"))return -25+cost/100
    if (name.includes("Pillbox"))return -25-cost/100

    if (name.startsWith("R-Vehicle-Body"))return -12+5*(!(name.includes("1")|name.includes("5")))//|x.includes("2")|x.includes("6")|x.includes("9")
    
    if (name.startsWith("R-Sys-Sensor-Upgrade"))return -11
    if (name.startsWith("R-Struc-Power"))return -10
    if (name.startsWith("R-Sys-Engineering"))return -9

    if (name.startsWith("R-Defense-WallUpgrade"))return -5
    if (name.startsWith("R-Struc-"))return -1-cost/100

    return -cost/100
}




function monoResearch(lab)
{
    var research=enumResearch()
    if (research.length==0)return
    pursueResearch(lab,min(research,x=>goodResearch(x.id)).id)
}

function monoFactory(factory)
{
    var _droidBase=[
        ["Body14SUP","Body13SUP","Body10MBT","Body7ABT","Body9REC","Body12SUP","Body11ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
        ['HalfTrack','wheeled01'],0,0]

    var weapon=(countDroid(DROID_CONSTRUCT,me)<10)?"Spade1Mk1":["PlasmiteFlamer","Flame2","Flame1Mk1"]//["HeavyLaser","Laser2PULSEMk1","Laser3BEAMMk1","MG5TWINROTARY","MG4ROTARYMk1","MG3Mk1","MG2Mk1","MG1Mk1"]
    buildDroid(factory,"tank",..._droidBase,weapon,weapon)
}

function monoFactory2(factoryCyborg)
{
    var w=["Cyb-Wpn-Thermite","CyborgFlamer01"]
    return buildDroid(factoryCyborg,"cyborg","CyborgLightBody",'CyborgLegs',0,0,w)
}




/** build as a larger building will preserve more space */
function spamBuild(truck,struct="A0PowerGenerator",near,as)
{
    if (near===undefined)near=truck
    if (as===undefined)as=struct
    var pos=pickStructLocation(truck,as,near.x,near.y)
    if (struct=="A0ResourceExtractor")pos=near
    if (pos===undefined)return
    return orderDroidBuild(truck, DORDER_BUILD, struct, pos.x,pos.y)
}




function zStruct()
{
    var lab=enumStruct(me,RESEARCH_LAB)
    var factory=enumStruct(me,FACTORY)
    var cyborg_factory=enumStruct(me,CYBORG_FACTORY)

    lab.filter(structureIdle).forEach(monoResearch)
    cyborg_factory.filter(structureIdle).forEach(monoFactory2)
    factory.filter(structureIdle).forEach(monoFactory)
}

function zDroid()
{   
    var truckTeam=enumDroid(me,DROID_CONSTRUCT)//.filter(x=>urandom(x.id+gameTime)<0.2)
    var weaponTeam=enumDroid(me).filter(droid=>droid.droidType==DROID_CYBORG || droid.droidType==DROID_WEAPON)
    if (playerPower(me)>1000)
    {
    truckTeam.forEach((truck)=>{
        if (truck.order==DORDER_BUILD || truck.order==DORDER_HELPBUILD)return
        var bunker=isStructureAvailable("Tower-Projector",me)?"Tower-Projector":"PillBox5"//isStructureAvailable("Pillbox-RotMG",me)?"Pillbox-RotMG":"PillBox1"
        spamBuild(truck,bunker,truck,"A0PowerGenerator")
    })
    }
    var home=startPositions[me]
    var dd=(16+(gameTime/800)%24)
    if ((enemyPlayer!==null) && ((weaponTeam.length>countDroid(DROID_ANY,enemy)*.8) || (weaponTeam.length>getDroidLimit(me)*.8) || (distBetweenTwoPoints(enemy.x,enemy.y,home.x,home.y) < dd)) )
    {
        var home2=startPositions[enemyPlayer]
        weaponTeam.forEach((weapon)=>{
            if (distBetweenTwoPoints(weapon.x,weapon.y,home2.x,home2.y)>16)orderDroidLoc(weapon,DORDER_MOVE,home2.x,home2.y)
            else orderDroidLoc(weapon,DORDER_PATROL,home2.x+Math.random()*10,home2.y+Math.random()*10)
        })
    }
    else
    {
        weaponTeam.forEach((weapon)=>{
            if (distBetweenTwoPoints(weapon.x,weapon.y,home.x,home.y)>dd)orderDroidLoc(weapon,DORDER_MOVE,home.x,home.y)
            else orderDroidLoc(weapon,DORDER_MOVE,enemy.x,enemy.y)
        })
    }
}




function eventStartLevel() 
{
    setTimer("zDroid", 499+me*3); 
    setTimer("zStruct", 599+me*3); 
}
function eventAttacked(victim,attacker)
{
    enemy=attacker
    enemyPlayer=attacker.player
}